"use strict";

require("core-js/modules/es6.symbol.js");

require("core-js/modules/es6.string.iterator.js");

require("core-js/modules/es6.object.to-string.js");

require("core-js/modules/es6.array.iterator.js");

require("core-js/modules/web.dom.iterable.js");

require("core-js/modules/es6.object.get-own-property-descriptor.js");

require("core-js/modules/es7.object.get-own-property-descriptors.js");

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.createFilter = createFilter;

require("core-js/modules/es6.array.map.js");

require("core-js/modules/es6.object.keys.js");

require("core-js/modules/es6.array.filter.js");

require("core-js/modules/es6.string.includes.js");

require("core-js/modules/es7.array.includes.js");

require("core-js/modules/es6.object.assign.js");

function ownKeys(object, enumerableOnly) { var keys = Object.keys(object); if (Object.getOwnPropertySymbols) { var symbols = Object.getOwnPropertySymbols(object); if (enumerableOnly) symbols = symbols.filter(function (sym) { return Object.getOwnPropertyDescriptor(object, sym).enumerable; }); keys.push.apply(keys, symbols); } return keys; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; if (i % 2) { ownKeys(Object(source), true).forEach(function (key) { _defineProperty(target, key, source[key]); }); } else if (Object.getOwnPropertyDescriptors) { Object.defineProperties(target, Object.getOwnPropertyDescriptors(source)); } else { ownKeys(Object(source)).forEach(function (key) { Object.defineProperty(target, key, Object.getOwnPropertyDescriptor(source, key)); }); } } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function _typeof(obj) { "@babel/helpers - typeof"; if (typeof Symbol === "function" && typeof Symbol.iterator === "symbol") { _typeof = function _typeof(obj) { return typeof obj; }; } else { _typeof = function _typeof(obj) { return obj && typeof Symbol === "function" && obj.constructor === Symbol && obj !== Symbol.prototype ? "symbol" : typeof obj; }; } return _typeof(obj); }

function createFilter(map) {
  var valueMap = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
  var options = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : {};
  var list = Object.keys(map).map(function (value) {
    var label = map[value];
    var rest = {};

    if (label && _typeof(label) === 'object') {
      var labelObj = label;
      Object.keys(labelObj).forEach(function (key) {
        if (key === 'label') label = labelObj[key];else rest[key] = labelObj[key];
      });
    }

    return _objectSpread({
      value: value,
      label: label
    }, rest);
  });

  var createList = function createList(values) {
    return list.filter(function (v) {
      return values.includes(v.value);
    });
  };

  var filter = options.filter || function (value) {
    var label = map[value];
    if (!label) return '';
    return _typeof(label) === 'object' ? label.label : label;
  };

  filter.list = list;
  filter.createList = createList;
  Object.keys(map).forEach(function (value) {
    if (!value) return;
    var key = /^\d+$/.test(value) ? valueMap[value] : value;
    if (key === undefined) return;
    filter[key] = value;
  });
  var external = options.external;

  if (external) {
    if (typeof external === 'function') external = external(filter);
    external && Object.assign(filter, external);
  }

  return filter;
}
//# sourceMappingURL=index.js.map